<!DOCTYPE html><html><head>
    <meta charset="utf-8"/>
    <meta name="author" content="Apple Inc."/>
    <meta name="viewport" content="width=device-width initial-scale=1"/>
    
    <a class="dashingAutolink" name="autolink-79"></a><a class="dashAnchor" name="//apple_ref/cpp/Guide/Error%20Handling%20%E2%80%94%20The%20Swift%20Programming%20Language%20%28Swift%204.2%29"></a><title>Error Handling &mdash; The Swift Programming Language (Swift 4.2)</title>
    
    <link rel="license" href="https://docs.swift.org/LICENSE.txt"/>
    <link rel="stylesheet" media="all" href="../_static/stylesheets/application.css"/>
    <link rel="stylesheet" media="all" href="../_static/stylesheets/tspl.css"/>
    <link rel="shortcut icon" sizes="16x16 24x24 32x32 48x48 64x64" type="image/vnd.microsoft.icon" href="../../favicon.ico"/>
    <link rel="apple-touch-icon" href="https://docs.swift.org/apple-touch-icon.png"/>
    <link rel="apple-touch-icon" sizes="57x57" href="https://docs.swift.org/apple-touch-icon-57x57.png"/>
    <link rel="apple-touch-icon" sizes="72x72" href="https://docs.swift.org/apple-touch-icon-72x72.png"/>
    <link rel="apple-touch-icon" sizes="76x76" href="https://docs.swift.org/apple-touch-icon-76x76.png"/>
    <link rel="apple-touch-icon" sizes="114x114" href="https://docs.swift.org/apple-touch-icon-114x114.png"/>
    <link rel="apple-touch-icon" sizes="120x120" href="https://docs.swift.org/apple-touch-icon-120x120.png"/>
    <link rel="apple-touch-icon" sizes="144x144" href="https://docs.swift.org/apple-touch-icon-144x144.png"/>
    <link rel="apple-touch-icon" sizes="152x152" href="https://docs.swift.org/apple-touch-icon-152x152.png"/>
    <link rel="apple-touch-icon" sizes="180x180" href="https://docs.swift.org/apple-touch-icon-180x180.png"/>
    <link rel="mask-icon" href="https://docs.swift.org/assets/images/icon-swift.svg" color="#F05339"/> 
  </head>
  <body>


<nav role="navigation">
    <header role="banner">
      <h1 id="logo">
        <a href="https://swift.org/" title="Swift.org" role="img" aria-label="Swift.org">
          Swift.org
        </a>
      </h1>
    </header>

    <div id="menu-toggle" class="menu-toggle open"></div>

    <h2>The Swift Programming Language<div>Swift 4.2</div></h2>

    <ul>
    <ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../index.html">Welcome to Swift</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="TheBasics.html">Language Guide</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="TheBasics.html">The Basics</a></li>
<li class="toctree-l2"><a class="reference internal" href="BasicOperators.html">Basic Operators</a></li>
<li class="toctree-l2"><a class="reference internal" href="StringsAndCharacters.html">Strings and Characters</a></li>
<li class="toctree-l2"><a class="reference internal" href="CollectionTypes.html">Collection Types</a></li>
<li class="toctree-l2"><a class="reference internal" href="ControlFlow.html">Control Flow</a></li>
<li class="toctree-l2"><a class="reference internal" href="Functions.html">Functions</a></li>
<li class="toctree-l2"><a class="reference internal" href="Closures.html">Closures</a></li>
<li class="toctree-l2"><a class="reference internal" href="Enumerations.html">Enumerations</a></li>
<li class="toctree-l2"><a class="reference internal" href="ClassesAndStructures.html">Structures and Classes</a></li>
<li class="toctree-l2"><a class="reference internal" href="Properties.html">Properties</a></li>
<li class="toctree-l2"><a class="reference internal" href="Methods.html">Methods</a></li>
<li class="toctree-l2"><a class="reference internal" href="Subscripts.html">Subscripts</a></li>
<li class="toctree-l2"><a class="reference internal" href="Inheritance.html">Inheritance</a></li>
<li class="toctree-l2"><a class="reference internal" href="Initialization.html">Initialization</a></li>
<li class="toctree-l2"><a class="reference internal" href="Deinitialization.html">Deinitialization</a></li>
<li class="toctree-l2"><a class="reference internal" href="OptionalChaining.html">Optional Chaining</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="ErrorHandling.html#">Error Handling</a></li>
<li class="toctree-l2"><a class="reference internal" href="TypeCasting.html">Type Casting</a></li>
<li class="toctree-l2"><a class="reference internal" href="NestedTypes.html">Nested Types</a></li>
<li class="toctree-l2"><a class="reference internal" href="Extensions.html">Extensions</a></li>
<li class="toctree-l2"><a class="reference internal" href="Protocols.html">Protocols</a></li>
<li class="toctree-l2"><a class="reference internal" href="Generics.html">Generics</a></li>
<li class="toctree-l2"><a class="reference internal" href="AutomaticReferenceCounting.html">Automatic Reference Counting</a></li>
<li class="toctree-l2"><a class="reference internal" href="MemorySafety.html">Memory Safety</a></li>
<li class="toctree-l2"><a class="reference internal" href="AccessControl.html">Access Control</a></li>
<li class="toctree-l2"><a class="reference internal" href="AdvancedOperators.html">Advanced Operators</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../ReferenceManual/AboutTheLanguageReference.html">Language Reference</a></li>
<li class="toctree-l1"><a class="reference internal" href="../RevisionHistory/RevisionHistory.html">Revision History</a></li>
</ul>

    <li class="toctree-l1 return"><a class="reference internal" href="https://swift.org/">&larr; Return to Swift.org</a></li>
    </ul>
</nav>




<main role="main">
    <article class="page">
        <menu id="bashful" type="toolbar">
          <div class="inner">
            <menuitem id="jump_to" class="menu-bar-item closed">
            <span id="jump_to_toggle">On This Page</span>
            <div class="chevron">
                <div class="chevy chevron-left"></div>
                <div class="chevy chevron-right"></div>
            </div>
            <menu type="list" class="details">
                <ul>
<li><a class="reference internal" href="ErrorHandling.html#">Error Handling</a><ul>
<li><a class="reference internal" href="ErrorHandling.html#ID509">Representing and Throwing Errors</a></li>
<li><a class="reference internal" href="ErrorHandling.html#ID512">Handling Errors</a><ul>
<li><a class="reference internal" href="ErrorHandling.html#ID510">Propagating Errors Using Throwing Functions</a></li>
<li><a class="reference internal" href="ErrorHandling.html#ID541">Handling Errors Using Do-Catch</a></li>
<li><a class="reference internal" href="ErrorHandling.html#ID542">Converting Errors to Optional Values</a></li>
<li><a class="reference internal" href="ErrorHandling.html#ID513">Disabling Error Propagation</a></li>
</ul>
</li>
<li><a class="reference internal" href="ErrorHandling.html#ID514">Specifying Cleanup Actions</a></li>
</ul>
</li>
</ul>

            </menu>
            </menuitem>
          </div>
        </menu>

        
  <div class="section" id="error-handling">
<h1>Error Handling<a class="headerlink" href="ErrorHandling.html#error-handling" title="Permalink to this headline"></a></h1>
<p><em>Error handling</em> is the process of responding to and recovering from error conditions in your program. Swift provides first-class support for throwing, catching, propagating, and manipulating recoverable errors at runtime.</p>
<p>Some operations aren&rsquo;t guaranteed to always complete execution or produce a useful output. Optionals are used to represent the absence of a value, but when an operation fails, it&rsquo;s often useful to understand what caused the failure, so that your code can respond accordingly.</p>
<p>As an example, consider the task of reading and processing data from a file on disk. There are a number of ways this task can fail, including the file not existing at the specified path, the file not having read permissions, or the file not being encoded in a compatible format. Distinguishing among these different situations allows a program to resolve some errors and to communicate to the user any errors it can&rsquo;t resolve.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">Error handling in Swift interoperates with error handling patterns that use the <code class="docutils literal"><span class="pre">NSError</span></code> class in Cocoa and Objective-C. For more information about this class, see <a class="reference external" href="https://developer.apple.com/documentation/swift/cocoa_design_patterns/handling_cocoa_errors_in_swift">Handling Cocoa Errors in Swift</a>.</p>
</div>
<div class="section" id="ID509">
<a class="dashingAutolink" name="autolink-80"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Representing%20and%20Throwing%20Errors"></a><h2>Representing and Throwing Errors<a class="headerlink" href="ErrorHandling.html#ID509" title="Permalink to this headline"></a></h2>
<p>In Swift, errors are represented by values of types that conform to the <code class="docutils literal"><span class="pre">Error</span></code> protocol. This empty protocol indicates that a type can be used for error handling.</p>
<p>Swift enumerations are particularly well suited to modeling a group of related error conditions, with associated values allowing for additional information about the nature of an error to be communicated. For example, here&rsquo;s how you might represent the error conditions of operating a vending machine inside a game:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">enum</span> <span class="nv">VendingMachineError</span>: <span class="nc">Error</span> {
</li><li>    <span class="k">case</span> <span class="nv">invalidSelection</span>
</li><li>    <span class="k">case</span> <span class="nv">insufficientFunds</span>(<span class="nv">coinsNeeded</span>: <span class="nv">Int</span>)
</li><li>    <span class="k">case</span> <span class="nv">outOfStock</span>
</li><li>}
</li></ol></pre></div></div>
<p>Throwing an error lets you indicate that something unexpected happened and the normal flow of execution can&rsquo;t continue. You use a <code class="docutils literal"><span class="pre">throw</span></code> statement to throw an error. For example, the following code throws an error to indicate that five additional coins are needed by the vending machine:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">throw</span> <span class="nv">VendingMachineError</span>.<span class="nv">insufficientFunds</span>(<span class="nv">coinsNeeded</span>: <span class="m">5</span>)
</li></ol></pre></div></div>
</div>
<div class="section" id="ID512">
<a class="dashingAutolink" name="autolink-81"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Handling%20Errors"></a><h2>Handling Errors<a class="headerlink" href="ErrorHandling.html#ID512" title="Permalink to this headline"></a></h2>
<p>When an error is thrown, some surrounding piece of code must be responsible for handling the error&mdash;for example, by correcting the problem, trying an alternative approach, or informing the user of the failure.</p>
<p>There are four ways to handle errors in Swift. You can propagate the error from a function to the code that calls that function, handle the error using a <code class="docutils literal"><span class="pre">do</span></code>-<code class="docutils literal"><span class="pre">catch</span></code> statement, handle the error as an optional value, or assert that the error will not occur. Each approach is described in a section below.</p>
<p>When a function throws an error, it changes the flow of your program, so it&rsquo;s important that you can quickly identify places in your code that can throw errors. To identify these places in your code, write the <code class="docutils literal"><span class="pre">try</span></code> keyword&mdash;or the <code class="docutils literal"><span class="pre">try?</span></code> or <code class="docutils literal"><span class="pre">try!</span></code> variation&mdash;before a piece of code that calls a function, method, or initializer that can throw an error. These keywords are described in the sections below.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">Error handling in Swift resembles exception handling in other languages, with the use of the <code class="docutils literal"><span class="pre">try</span></code>, <code class="docutils literal"><span class="pre">catch</span></code> and <code class="docutils literal"><span class="pre">throw</span></code> keywords. Unlike exception handling in many languages&mdash;including Objective-C&mdash;error handling in Swift does not involve unwinding the call stack, a process that can be computationally expensive. As such, the performance characteristics of a <code class="docutils literal"><span class="pre">throw</span></code> statement are comparable to those of a <code class="docutils literal"><span class="pre">return</span></code> statement.</p>
</div>
<div class="section" id="ID510">
<h3>Propagating Errors Using Throwing Functions<a class="headerlink" href="ErrorHandling.html#ID510" title="Permalink to this headline"></a></h3>
<p>To indicate that a function, method, or initializer can throw an error, you write the <code class="docutils literal"><span class="pre">throws</span></code> keyword in the function&rsquo;s declaration after its parameters. A function marked with <code class="docutils literal"><span class="pre">throws</span></code> is called a <em>throwing function</em>. If the function specifies a return type, you write the <code class="docutils literal"><span class="pre">throws</span></code> keyword before the return arrow (<code class="docutils literal"><span class="pre">-&gt;</span></code>).</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">func</span> <span class="nv">canThrowErrors</span>() <span class="k">throws</span> -&gt; <span class="nc">String</span>
</li><li>
</li><li><span class="k">func</span> <span class="nv">cannotThrowErrors</span>() -&gt; <span class="nc">String</span>
</li></ol></pre></div></div>
<p>A throwing function propagates errors that are thrown inside of it to the scope from which it&rsquo;s called.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">Only throwing functions can propagate errors. Any errors thrown inside a nonthrowing function must be handled inside the function.</p>
</div>
<p>In the example below, the <code class="docutils literal"><span class="pre">VendingMachine</span></code> class has a <code class="docutils literal"><span class="pre">vend(itemNamed:)</span></code> method that throws an appropriate <code class="docutils literal"><span class="pre">VendingMachineError</span></code> if the requested item is not available, is out of stock, or has a cost that exceeds the current deposited amount:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">struct</span> <span class="nv">Item</span> {
</li><li>    <span class="k">var</span> <span class="nv">price</span>: <span class="nc">Int</span>
</li><li>    <span class="k">var</span> <span class="nv">count</span>: <span class="nc">Int</span>
</li><li>}
</li><li>
</li><li><span class="k">class</span> <span class="nv">VendingMachine</span> {
</li><li>    <span class="k">var</span> <span class="nv">inventory</span> = [
</li><li>        <span class="s">&#34;Candy Bar&#34;</span>: <span class="nv">Item</span>(<span class="nv">price</span>: <span class="m">12</span>, <span class="nv">count</span>: <span class="m">7</span>),
</li><li>        <span class="s">&#34;Chips&#34;</span>: <span class="nv">Item</span>(<span class="nv">price</span>: <span class="m">10</span>, <span class="nv">count</span>: <span class="m">4</span>),
</li><li>        <span class="s">&#34;Pretzels&#34;</span>: <span class="nv">Item</span>(<span class="nv">price</span>: <span class="m">7</span>, <span class="nv">count</span>: <span class="m">11</span>)
</li><li>    ]
</li><li>    <span class="k">var</span> <span class="nv">coinsDeposited</span> = <span class="m">0</span>
</li><li>
</li><li>    <span class="k">func</span> <span class="nv">vend</span>(<span class="nv">itemNamed</span> <span class="nv">name</span>: <span class="nc">String</span>) <span class="k">throws</span> {
</li><li>        <span class="k">guard</span> <span class="k">let</span> <span class="nv">item</span> = <span class="nv">inventory</span>[<span class="nv">name</span>] <span class="k">else</span> {
</li><li>            <span class="k">throw</span> <span class="nv">VendingMachineError</span>.<span class="nv">invalidSelection</span>
</li><li>        }
</li><li>
</li><li>        <span class="k">guard</span> <span class="nv">item</span>.<span class="nv">count</span> &gt; <span class="m">0</span> <span class="k">else</span> {
</li><li>            <span class="k">throw</span> <span class="nv">VendingMachineError</span>.<span class="nv">outOfStock</span>
</li><li>        }
</li><li>
</li><li>        <span class="k">guard</span> <span class="nv">item</span>.<span class="nv">price</span> &lt;= <span class="nv">coinsDeposited</span> <span class="k">else</span> {
</li><li>            <span class="k">throw</span> <span class="nv">VendingMachineError</span>.<span class="nv">insufficientFunds</span>(<span class="nv">coinsNeeded</span>: <span class="nv">item</span>.<span class="nv">price</span> - <span class="nv">coinsDeposited</span>)
</li><li>        }
</li><li>
</li><li>        <span class="nv">coinsDeposited</span> -= <span class="nv">item</span>.<span class="nv">price</span>
</li><li>
</li><li>        <span class="k">var</span> <span class="nv">newItem</span> = <span class="nv">item</span>
</li><li>        <span class="nv">newItem</span>.<span class="nv">count</span> -= <span class="m">1</span>
</li><li>        <span class="nv">inventory</span>[<span class="nv">name</span>] = <span class="nv">newItem</span>
</li><li>
</li><li>        <span class="nv">print</span>(<span class="s">&#34;Dispensing </span>\<span class="p">(</span><span class="nv">name</span><span class="p">)</span><span class="s">&#34;</span>)
</li><li>    }
</li><li>}
</li></ol></pre></div></div>
<p>The implementation of the <code class="docutils literal"><span class="pre">vend(itemNamed:)</span></code> method uses <code class="docutils literal"><span class="pre">guard</span></code> statements to exit the method early and throw appropriate errors if any of the requirements for purchasing a snack aren&rsquo;t met. Because a <code class="docutils literal"><span class="pre">throw</span></code> statement immediately transfers program control, an item will be vended only if all of these requirements are met.</p>
<p>Because the <code class="docutils literal"><span class="pre">vend(itemNamed:)</span></code> method propagates any errors it throws, any code that calls this method must either handle the errors&mdash;using a <code class="docutils literal"><span class="pre">do</span></code>-<code class="docutils literal"><span class="pre">catch</span></code> statement, <code class="docutils literal"><span class="pre">try?</span></code>, or <code class="docutils literal"><span class="pre">try!</span></code>&mdash;or continue to propagate them. For example, the <code class="docutils literal"><span class="pre">buyFavoriteSnack(person:vendingMachine:)</span></code> in the example below is also a throwing function, and any errors that the <code class="docutils literal"><span class="pre">vend(itemNamed:)</span></code> method throws will propagate up to the point where the <code class="docutils literal"><span class="pre">buyFavoriteSnack(person:vendingMachine:)</span></code> function is called.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">favoriteSnacks</span> = [
</li><li>    <span class="s">&#34;Alice&#34;</span>: <span class="s">&#34;Chips&#34;</span>,
</li><li>    <span class="s">&#34;Bob&#34;</span>: <span class="s">&#34;Licorice&#34;</span>,
</li><li>    <span class="s">&#34;Eve&#34;</span>: <span class="s">&#34;Pretzels&#34;</span>,
</li><li>]
</li><li><span class="k">func</span> <span class="nv">buyFavoriteSnack</span>(<span class="nv">person</span>: <span class="nc">String</span>, <span class="nv">vendingMachine</span>: <span class="nc">VendingMachine</span>) <span class="k">throws</span> {
</li><li>    <span class="k">let</span> <span class="nv">snackName</span> = <span class="nv">favoriteSnacks</span>[<span class="nv">person</span>] ?? <span class="s">&#34;Candy Bar&#34;</span>
</li><li>    <span class="k">try</span> <span class="nv">vendingMachine</span>.<span class="nv">vend</span>(<span class="nv">itemNamed</span>: <span class="nv">snackName</span>)
</li><li>}
</li></ol></pre></div></div>
<p>In this example, the <code class="docutils literal"><span class="pre">buyFavoriteSnack(person:</span> <span class="pre">vendingMachine:)</span></code> function looks up a given person&rsquo;s favorite snack and tries to buy it for them by calling the <code class="docutils literal"><span class="pre">vend(itemNamed:)</span></code> method. Because the <code class="docutils literal"><span class="pre">vend(itemNamed:)</span></code> method can throw an error, it&rsquo;s called with the <code class="docutils literal"><span class="pre">try</span></code> keyword in front of it.</p>
<p>Throwing initializers can propagate errors in the same way as throwing functions. For example, the initializer for the <code class="docutils literal"><span class="pre">PurchasedSnack</span></code> structure in the listing below calls a throwing function as part of the initialization process, and it handles any errors that it encounters by propagating them to its caller.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">struct</span> <span class="nv">PurchasedSnack</span> {
</li><li>    <span class="k">let</span> <span class="nv">name</span>: <span class="nc">String</span>
</li><li>    <span class="k">init</span>(<span class="nv">name</span>: <span class="nc">String</span>, <span class="nv">vendingMachine</span>: <span class="nc">VendingMachine</span>) <span class="k">throws</span> {
</li><li>        <span class="k">try</span> <span class="nv">vendingMachine</span>.<span class="nv">vend</span>(<span class="nv">itemNamed</span>: <span class="nv">name</span>)
</li><li>        <span class="k">self</span>.<span class="nv">name</span> = <span class="nv">name</span>
</li><li>    }
</li><li>}
</li></ol></pre></div></div>
</div>
<div class="section" id="ID541">
<h3>Handling Errors Using Do-Catch<a class="headerlink" href="ErrorHandling.html#ID541" title="Permalink to this headline"></a></h3>
<p>You use a <code class="docutils literal"><span class="pre">do</span></code>-<code class="docutils literal"><span class="pre">catch</span></code> statement to handle errors by running a block of code. If an error is thrown by the code in the <code class="docutils literal"><span class="pre">do</span></code> clause, it is matched against the <code class="docutils literal"><span class="pre">catch</span></code> clauses to determine which one of them can handle the error.</p>
<p>Here is the general form of a <code class="docutils literal"><span class="pre">do</span></code>-<code class="docutils literal"><span class="pre">catch</span></code> statement:</p>
<div class="syntax-outline highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">do</span> {
</li><li>    <span class="k">try</span> <span class="gi">expression</span>
</li><li>    <span class="gi">statements</span>
</li><li>} <span class="k">catch</span> <span class="gi">pattern 1</span> {
</li><li>    <span class="gi">statements</span>
</li><li>} <span class="k">catch</span> <span class="gi">pattern 2</span> <span class="k">where</span> <span class="gi">condition</span> {
</li><li>    <span class="gi">statements</span>
</li><li>} <span class="k">catch</span> {
</li><li>    <span class="gi">statements</span>
</li><li>}
</li></ol></pre></div></div>
<p>You write a pattern after <code class="docutils literal"><span class="pre">catch</span></code> to indicate what errors that clause can handle. If a <code class="docutils literal"><span class="pre">catch</span></code> clause doesn&rsquo;t have a pattern, the clause matches any error and binds the error to a local constant named <code class="docutils literal"><span class="pre">error</span></code>. For more information about pattern matching, see <a class="reference internal" href="../ReferenceManual/Patterns.html"><span class="doc">Patterns</span></a>.</p>
<p>For example, the following code matches against all three cases of the <code class="docutils literal"><span class="pre">VendingMachineError</span></code> enumeration.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">var</span> <span class="nv">vendingMachine</span> = <span class="nv">VendingMachine</span>()
</li><li><span class="nv">vendingMachine</span>.<span class="nv">coinsDeposited</span> = <span class="m">8</span>
</li><li><span class="k">do</span> {
</li><li>    <span class="k">try</span> <span class="nv">buyFavoriteSnack</span>(<span class="nv">person</span>: <span class="s">&#34;Alice&#34;</span>, <span class="nv">vendingMachine</span>: <span class="nv">vendingMachine</span>)
</li><li>    <span class="nv">print</span>(<span class="s">&#34;Success! Yum.&#34;</span>)
</li><li>} <span class="k">catch</span> <span class="nv">VendingMachineError</span>.<span class="nv">invalidSelection</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&#34;Invalid Selection.&#34;</span>)
</li><li>} <span class="k">catch</span> <span class="nv">VendingMachineError</span>.<span class="nv">outOfStock</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&#34;Out of Stock.&#34;</span>)
</li><li>} <span class="k">catch</span> <span class="nv">VendingMachineError</span>.<span class="nv">insufficientFunds</span>(<span class="k">let</span> <span class="nv">coinsNeeded</span>) {
</li><li>    <span class="nv">print</span>(<span class="s">&#34;Insufficient funds. Please insert an additional </span>\<span class="p">(</span><span class="nv">coinsNeeded</span><span class="p">)</span><span class="s"> coins.&#34;</span>)
</li><li>} <span class="k">catch</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&#34;Unexpected error: </span>\<span class="p">(</span><span class="nv">error</span><span class="p">)</span><span class="s">.&#34;</span>)
</li><li>}
</li><li><span class="c">// Prints &#34;Insufficient funds. Please insert an additional 2 coins.&#34;</span>
</li></ol></pre></div></div>
<p>In the above example, the <code class="docutils literal"><span class="pre">buyFavoriteSnack(person:vendingMachine:)</span></code> function is called in a <code class="docutils literal"><span class="pre">try</span></code> expression, because it can throw an error. If an error is thrown, execution immediately transfers to the <code class="docutils literal"><span class="pre">catch</span></code> clauses, which decide whether to allow propagation to continue. If no pattern is matched, the error gets caught by the final <code class="docutils literal"><span class="pre">catch</span></code> clause and is bound to a local <code class="docutils literal"><span class="pre">error</span></code> constant. If no error is thrown, the remaining statements in the <code class="docutils literal"><span class="pre">do</span></code> statement are executed.</p>
<p>The <code class="docutils literal"><span class="pre">catch</span></code> clauses don&rsquo;t have to handle every possible error that the code in the <code class="docutils literal"><span class="pre">do</span></code> clause can throw. If none of the <code class="docutils literal"><span class="pre">catch</span></code> clauses handle the error, the error propagates to the surrounding scope. However, the propagated error must be handled by <em>some</em> surrounding scope. In a nonthrowing function, an enclosing <code class="docutils literal"><span class="pre">do</span></code>-<code class="docutils literal"><span class="pre">catch</span></code> clause must handle the error. In a throwing function, either an enclosing <code class="docutils literal"><span class="pre">do</span></code>-<code class="docutils literal"><span class="pre">catch</span></code> clause or the caller must handle the error. If the error propagates to the top-level scope without being handled, you&rsquo;ll get a runtime error.</p>
<p>For example, the above example can be written so any error that isn&rsquo;t a <code class="docutils literal"><span class="pre">VendingMachineError</span></code> is instead caught by the calling function:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">func</span> <span class="nv">nourish</span>(<span class="nv">with</span> <span class="nv">item</span>: <span class="nc">String</span>) <span class="k">throws</span> {
</li><li>    <span class="k">do</span> {
</li><li>        <span class="k">try</span> <span class="nv">vendingMachine</span>.<span class="nv">vend</span>(<span class="nv">itemNamed</span>: <span class="nv">item</span>)
</li><li>    } <span class="k">catch</span> <span class="k">is</span> <span class="nc">VendingMachineError</span> {
</li><li>        <span class="nv">print</span>(<span class="s">&#34;Invalid selection, out of stock, or not enough money.&#34;</span>)
</li><li>    }
</li><li>}
</li><li>
</li><li><span class="k">do</span> {
</li><li>    <span class="k">try</span> <span class="nv">nourish</span>(<span class="nv">with</span>: <span class="s">&#34;Beet-Flavored Chips&#34;</span>)
</li><li>} <span class="k">catch</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&#34;Unexpected non-vending-machine-related error: </span>\<span class="p">(</span><span class="nv">error</span><span class="p">)</span><span class="s">&#34;</span>)
</li><li>}
</li><li><span class="c">// Prints &#34;Invalid selection, out of stock, or not enough money.&#34;</span>
</li></ol></pre></div></div>
<p>In the <code class="docutils literal"><span class="pre">nourish(with:)</span></code> function, if <code class="docutils literal"><span class="pre">vend(itemNamed:)</span></code> throws an error that&rsquo;s one of the cases of the <code class="docutils literal"><span class="pre">VendingMachineError</span></code> enumeration, <code class="docutils literal"><span class="pre">nourish(with:)</span></code> handles the error by printing a message. Otherwise, <code class="docutils literal"><span class="pre">nourish(with:)</span></code> propagates the error to its call site. The error is then caught by the general <code class="docutils literal"><span class="pre">catch</span></code> clause.</p>
</div>
<div class="section" id="ID542">
<h3>Converting Errors to Optional Values<a class="headerlink" href="ErrorHandling.html#ID542" title="Permalink to this headline"></a></h3>
<p>You use <code class="docutils literal"><span class="pre">try?</span></code> to handle an error by converting it to an optional value. If an error is thrown while evaluating the <code class="docutils literal"><span class="pre">try?</span></code> expression, the value of the expression is <code class="docutils literal"><span class="pre">nil</span></code>. For example, in the following code <code class="docutils literal"><span class="pre">x</span></code> and <code class="docutils literal"><span class="pre">y</span></code> have the same value and behavior:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">func</span> <span class="nv">someThrowingFunction</span>() <span class="k">throws</span> -&gt; <span class="nc">Int</span> {
</li><li>    <span class="c">// ...</span>
</li><li>}
</li><li>
</li><li><span class="k">let</span> <span class="nv">x</span> = <span class="k">try</span>? <span class="nv">someThrowingFunction</span>()
</li><li>
</li><li><span class="k">let</span> <span class="nv">y</span>: <span class="nc">Int</span>?
</li><li><span class="k">do</span> {
</li><li>    <span class="nv">y</span> = <span class="k">try</span> <span class="nv">someThrowingFunction</span>()
</li><li>} <span class="k">catch</span> {
</li><li>    <span class="nv">y</span> = <span class="k">nil</span>
</li><li>}
</li></ol></pre></div></div>
<p>If <code class="docutils literal"><span class="pre">someThrowingFunction()</span></code> throws an error, the value of <code class="docutils literal"><span class="pre">x</span></code> and <code class="docutils literal"><span class="pre">y</span></code> is <code class="docutils literal"><span class="pre">nil</span></code>. Otherwise, the value of <code class="docutils literal"><span class="pre">x</span></code> and <code class="docutils literal"><span class="pre">y</span></code> is the value that the function returned. Note that <code class="docutils literal"><span class="pre">x</span></code> and <code class="docutils literal"><span class="pre">y</span></code> are an optional of whatever type <code class="docutils literal"><span class="pre">someThrowingFunction()</span></code> returns. Here the function returns an integer, so <code class="docutils literal"><span class="pre">x</span></code> and <code class="docutils literal"><span class="pre">y</span></code> are optional integers.</p>
<p>Using <code class="docutils literal"><span class="pre">try?</span></code> lets you write concise error handling code when you want to handle all errors in the same way. For example, the following code uses several approaches to fetch data, or returns <code class="docutils literal"><span class="pre">nil</span></code> if all of the approaches fail.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">func</span> <span class="nv">fetchData</span>() -&gt; <span class="nc">Data</span>? {
</li><li>    <span class="k">if</span> <span class="k">let</span> <span class="nv">data</span> = <span class="k">try</span>? <span class="nv">fetchDataFromDisk</span>() { <span class="k">return</span> <span class="nv">data</span> }
</li><li>    <span class="k">if</span> <span class="k">let</span> <span class="nv">data</span> = <span class="k">try</span>? <span class="nv">fetchDataFromServer</span>() { <span class="k">return</span> <span class="nv">data</span> }
</li><li>    <span class="k">return</span> <span class="k">nil</span>
</li><li>}
</li></ol></pre></div></div>
</div>
<div class="section" id="ID513">
<h3>Disabling Error Propagation<a class="headerlink" href="ErrorHandling.html#ID513" title="Permalink to this headline"></a></h3>
<p>Sometimes you know a throwing function or method won&rsquo;t, in fact, throw an error at runtime. On those occasions, you can write <code class="docutils literal"><span class="pre">try!</span></code> before the expression to disable error propagation and wrap the call in a runtime assertion that no error will be thrown. If an error actually is thrown, you&rsquo;ll get a runtime error.</p>
<p>For example, the following code uses a <code class="docutils literal"><span class="pre">loadImage(atPath:)</span></code> function, which loads the image resource at a given path or throws an error if the image can&rsquo;t be loaded. In this case, because the image is shipped with the application, no error will be thrown at runtime, so it is appropriate to disable error propagation.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">photo</span> = <span class="k">try</span>! <span class="nv">loadImage</span>(<span class="nv">atPath</span>: <span class="s">&#34;./Resources/John Appleseed.jpg&#34;</span>)
</li></ol></pre></div></div>
</div>
</div>
<div class="section" id="ID514">
<a class="dashingAutolink" name="autolink-82"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Specifying%20Cleanup%20Actions"></a><h2>Specifying Cleanup Actions<a class="headerlink" href="ErrorHandling.html#ID514" title="Permalink to this headline"></a></h2>
<p>You use a <code class="docutils literal"><span class="pre">defer</span></code> statement to execute a set of statements just before code execution leaves the current block of code. This statement lets you do any necessary cleanup that should be performed regardless of <em>how</em> execution leaves the current block of code&mdash;whether it leaves because an error was thrown or because of a statement such as <code class="docutils literal"><span class="pre">return</span></code> or <code class="docutils literal"><span class="pre">break</span></code>. For example, you can use a <code class="docutils literal"><span class="pre">defer</span></code> statement to ensure that file descriptors are closed and manually allocated memory is freed.</p>
<p>A <code class="docutils literal"><span class="pre">defer</span></code> statement defers execution until the current scope is exited. This statement consists of the <code class="docutils literal"><span class="pre">defer</span></code> keyword and the statements to be executed later. The deferred statements may not contain any code that would transfer control out of the statements, such as a <code class="docutils literal"><span class="pre">break</span></code> or a <code class="docutils literal"><span class="pre">return</span></code> statement, or by throwing an error. Deferred actions are executed in the reverse of the order that they&rsquo;re written in your source code. That is, the code in the first <code class="docutils literal"><span class="pre">defer</span></code> statement executes last, the code in the second <code class="docutils literal"><span class="pre">defer</span></code> statement executes second to last, and so on. The last <code class="docutils literal"><span class="pre">defer</span></code> statement in source code order executes first.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">func</span> <span class="nv">processFile</span>(<span class="nv">filename</span>: <span class="nc">String</span>) <span class="k">throws</span> {
</li><li>    <span class="k">if</span> <span class="nv">exists</span>(<span class="nv">filename</span>) {
</li><li>        <span class="k">let</span> <span class="nv">file</span> = <span class="nv">open</span>(<span class="nv">filename</span>)
</li><li>        <span class="k">defer</span> {
</li><li>            <span class="nv">close</span>(<span class="nv">file</span>)
</li><li>        }
</li><li>        <span class="k">while</span> <span class="k">let</span> <span class="nv">line</span> = <span class="k">try</span> <span class="nv">file</span>.<span class="nv">readline</span>() {
</li><li>            <span class="c">// Work with the file.</span>
</li><li>        }
</li><li>        <span class="c">// close(file) is called here, at the end of the scope.</span>
</li><li>    }
</li><li>}
</li></ol></pre></div></div>
<p>The above example uses a <code class="docutils literal"><span class="pre">defer</span></code> statement to ensure that the <code class="docutils literal"><span class="pre">open(_:)</span></code> function has a corresponding call to <code class="docutils literal"><span class="pre">close(_:)</span></code>.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">You can use a <code class="docutils literal"><span class="pre">defer</span></code> statement even when no error handling code is involved.</p>
</div>
</div>
</div>


    </article>
    <div class="next_previous">
        <p class="previous"><a href="OptionalChaining.html">Optional Chaining</a></p>
        <p class="next"><a href="TypeCasting.html">Type Casting</a></p>
    </div>

    <div class="admonition-beta admonition">
        <p class="first admonition-title">Beta Software</p>
        <p>
          This documentation contains preliminary information about an API or technology in development.
          This information is subject to change, and software implemented according to this documentation should be tested with final operating system software.
        </p>
        <p class="last"><a class="reference external" href="https://developer.apple.com/support/beta-software/">Learn more about using Apple&#39;s beta software</a></p>
    </div>
</main>


<footer role="contentinfo">
  <aside>
    <a href="https://swift.org/atom.xml" title="Subscribe to Site Updates"><i class="feed">Subscribe</i></a>
    <a href="https://twitter.com/swiftlang" rel="nofollow" title="Follow @SwiftLang on Twitter"><i class="twitter">Twitter</i></a>
  </aside>

  <p class="copyright">Copyright &copy; 2018 Apple Inc. All rights reserved.</p>
  <p class="trademark">Swift and the Swift logo are trademarks of Apple Inc.</p>
  <p class="privacy">
    <a href="https://www.apple.com/privacy/privacy-policy/">Privacy Policy</a>
    <a href="https://www.apple.com/legal/privacy/en-ww/cookies/">Cookies</a>
  </p>
</footer>
<div id="jump_to_overlay"></div>
<script src="../_static/javascripts/application.js"></script>
  

</body></html>